' MainWindow.xaml.cs by Charles Petzold, December 2008

Imports Microsoft.VisualBasic
Imports System
Imports System.Diagnostics
Imports System.Windows
Imports System.Windows.Input

Namespace DataDisplay
	Partial Public Class MainWindow
		Inherits Window
		Private stopWatch As Stopwatch

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub OnAttachDataCollectionClick(ByVal sender As Object, ByVal args As RoutedEventArgs)
			Dim numPoints As Integer

			If (Not Int32.TryParse(numPointsTextBox.Text, numPoints)) OrElse numPoints < 1 Then
				MessageBox.Show("Value must be positive")
			End If

			Cursor = Cursors.Wait
			stopWatch = Stopwatch.StartNew()

			' Create the data collection (method in DataDisplay#Control.xaml.cs)
			dataDisplayControl.CreateDataCollection(numPoints)

			time1TextBlock.Text = stopWatch.Elapsed.ToString()
			stopWatch.Reset()
			stopWatch.Start()

			' Assign the DataContext (method in DataDisplay#Control.xaml.cs)
			dataDisplayControl.AssignDataContext()

			time2TextBlock.Text = stopWatch.Elapsed.ToString()
			stopWatch.Reset()
			stopWatch.Start()

			' Now the real work begins during layout
			AddHandler LayoutUpdated, AddressOf OnLayoutUpdated
		End Sub

		Private Sub OnLayoutUpdated(ByVal sender As Object, ByVal args As EventArgs)
			time3TextBlock.Text = stopWatch.Elapsed.ToString()
			stopWatch.Stop()
			RemoveHandler LayoutUpdated, AddressOf OnLayoutUpdated
			Cursor = Cursors.Arrow
		End Sub
	End Class
End Namespace
