' DataDot.cs by Charles Petzold, December 2008

Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Media
Imports System.Windows.Shapes

Namespace DataLibrary
	Public Class DataDot
		Inherits FrameworkElement
		Public Shared ReadOnly CenterXProperty As DependencyProperty = DependencyProperty.Register("CenterX", GetType(Double), GetType(DataDot), New FrameworkPropertyMetadata(0.0, FrameworkPropertyMetadataOptions.AffectsMeasure Or FrameworkPropertyMetadataOptions.AffectsRender))

		Public Shared ReadOnly CenterYProperty As DependencyProperty = DependencyProperty.Register("CenterY", GetType(Double), GetType(DataDot), New FrameworkPropertyMetadata(0.0, FrameworkPropertyMetadataOptions.AffectsMeasure Or FrameworkPropertyMetadataOptions.AffectsRender))

		Public Shared ReadOnly RadiusXProperty As DependencyProperty = DependencyProperty.Register("RadiusX", GetType(Double), GetType(DataDot), New FrameworkPropertyMetadata(0.0, FrameworkPropertyMetadataOptions.AffectsMeasure Or FrameworkPropertyMetadataOptions.AffectsRender))

		Public Shared ReadOnly RadiusYProperty As DependencyProperty = DependencyProperty.Register("RadiusY", GetType(Double), GetType(DataDot), New FrameworkPropertyMetadata(0.0, FrameworkPropertyMetadataOptions.AffectsMeasure Or FrameworkPropertyMetadataOptions.AffectsRender))

		Public Shared ReadOnly BrushesProperty As DependencyProperty = DependencyProperty.Register("Brushes", GetType(Brush()), GetType(DataDot), New FrameworkPropertyMetadata(Nothing, FrameworkPropertyMetadataOptions.AffectsRender))

		Public Shared ReadOnly FillIndexProperty As DependencyProperty = DependencyProperty.Register("FillIndex", GetType(Integer), GetType(DataDot), New FrameworkPropertyMetadata(0, FrameworkPropertyMetadataOptions.AffectsRender))

		Public Property CenterX() As Double
			Set(ByVal value As Double)
				SetValue(CenterXProperty, value)
			End Set
			Get
				Return CDbl(GetValue(CenterXProperty))
			End Get
		End Property

		Public Property CenterY() As Double
			Set(ByVal value As Double)
				SetValue(CenterYProperty, value)
			End Set
			Get
				Return CDbl(GetValue(CenterYProperty))
			End Get
		End Property

		Public Property RadiusX() As Double
			Set(ByVal value As Double)
				SetValue(RadiusXProperty, value)
			End Set
			Get
				Return CDbl(GetValue(RadiusXProperty))
			End Get
		End Property

		Public Property RadiusY() As Double
			Set(ByVal value As Double)
				SetValue(RadiusYProperty, value)
			End Set
			Get
				Return CDbl(GetValue(RadiusYProperty))
			End Get
		End Property

		Public Property Brushes() As Brush()
			Set(ByVal value As Brush())
				SetValue(BrushesProperty, value)
			End Set
			Get
				Return CType(GetValue(BrushesProperty), Brush())
			End Get
		End Property

		Public Property FillIndex() As Integer
			Set(ByVal value As Integer)
				SetValue(FillIndexProperty, value)
			End Set
			Get
				Return CInt(Fix(GetValue(FillIndexProperty)))
			End Get
		End Property

		Protected Overrides Function MeasureOverride(ByVal availableSize As Size) As Size
			Return New Size(CenterX + RadiusX, CenterY + RadiusY)
		End Function

		Protected Overrides Sub OnRender(ByVal dc As DrawingContext)
			If Brushes IsNot Nothing Then
				dc.DrawEllipse(Brushes(FillIndex), Nothing, New Point(CenterX, CenterY), RadiusX, RadiusY)
			End If
		End Sub
	End Class
End Namespace