' DataPoint.cs by Charles Petzold, December 2008

Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel

Namespace DataLibrary
	Public Class DataPoint
		Implements INotifyPropertyChanged
		Private _type As Integer
		Private _variableX, _variableY As Double
		Private _id As String

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

		Public Property Type() As Integer
			Set(ByVal value As Integer)
				If _type <> value Then
					_type = value
					OnPropertyChanged("Type")
				End If
			End Set
			Get
				Return _type
			End Get
		End Property

		Public Property VariableX() As Double
			Set(ByVal value As Double)
				If _variableX <> value Then
					_variableX = value
					OnPropertyChanged("VariableX")
				End If
			End Set
			Get
				Return _variableX
			End Get
		End Property

		Public Property VariableY() As Double
			Set(ByVal value As Double)
				If _variableY <> value Then
					_variableY = value
					OnPropertyChanged("VariableY")
				End If
			End Set
			Get
				Return _variableY
			End Get
		End Property

		Public Property ID() As String
			Set(ByVal value As String)
				If _id <> value Then
					_id = value
					OnPropertyChanged("ID")
				End If
			End Set
			Get
				Return _id
			End Get
		End Property

		Protected Overridable Sub OnPropertyChanged(ByVal propertyName As String)
			RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
		End Sub
	End Class
End Namespace
