' DataPointPresenter.cs by Charles Petzold, December 2008

Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel
Imports System.Windows
Imports System.Windows.Media

Namespace DataLibrary
	Public Class DataPointPresenter
		Inherits DataPoint
		Private Shared ReadOnly _brushes() As Brush = { Brushes.Red, Brushes.Yellow, Brushes.Green, Brushes.Cyan, Brushes.Blue, Brushes.Magenta }
		Private _variable As Point
		Private _brush As Brush
		Private _tooltip As String

		Public Property Variable() As Point
			Set(ByVal value As Point)
				If _variable <> value Then
					_variable = value
					OnPropertyChanged("Variable")
				End If
			End Set
			Get
				Return _variable
			End Get
		End Property

		Public Property Brush() As Brush
			Set(ByVal value As Brush)
				If _brush IsNot value Then
					_brush = value
					OnPropertyChanged("Brush")
				End If
			End Set
			Get
				Return _brush
			End Get
		End Property

		Public Property ToolTip() As String
			Set(ByVal value As String)
				If _tooltip <> value Then
					_tooltip = value
					OnPropertyChanged("ToolTip")
				End If
			End Set
			Get
				Return _tooltip
			End Get
		End Property

		Protected Overrides Sub OnPropertyChanged(ByVal propertyName As String)
			Select Case propertyName
				Case "VariableX", "VariableY"
					Variable = New Point(VariableX, VariableY)
					GoTo CaseLabel1

				Case "ID"
				CaseLabel1:
					ToolTip = String.Format("{0}, X={1}, Y={2}", ID, VariableX, VariableY)

				Case "Type"
					Brush = _brushes(Type)
			End Select
			MyBase.OnPropertyChanged(propertyName)
		End Sub
	End Class
End Namespace
