' DataRandomizer.cs by Charles Petzold, December 2008

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Windows.Threading

Namespace DataLibrary
	Public Class DataRandomizer(Of T As {DataPoint, New})
		Private collection As IList(Of T)
		Private changePoints As Integer
		Private rand As New Random()

		Public Sub New(ByVal collection As IList(Of T), ByVal numPoints As Integer, ByVal changePoints As Integer)
			Me.collection = collection
			Me.changePoints = changePoints

			For i As Integer = 0 To numPoints - 1
				Dim dataPoint As New T()
				dataPoint.ID = FabricateIdString()
				dataPoint.Type = rand.Next(6)


				Select Case dataPoint.Type
					Case 0
						dataPoint.VariableX = rand.NextDouble()
						dataPoint.VariableY = 0.25 * rand.NextDouble() + 0.17 - 0.125

					Case 1
						dataPoint.VariableX = rand.NextDouble()
						dataPoint.VariableY = 0.25 * rand.NextDouble() + 0.50 - 0.125

					Case 2
						dataPoint.VariableX = rand.NextDouble()
						dataPoint.VariableY = 0.25 * rand.NextDouble() + 0.83 - 0.125

					Case 3
						dataPoint.VariableX = rand.NextDouble()
						dataPoint.VariableY = 0.75 * dataPoint.VariableX + 0.25 * rand.NextDouble()

					Case 4
						dataPoint.VariableX = rand.NextDouble()
						dataPoint.VariableY = 0.75 * (1 - dataPoint.VariableX) + 0.25 * rand.NextDouble()

					Case 5
						dataPoint.VariableX = 0.5 * rand.NextDouble() + 0.25
						dataPoint.VariableY = rand.NextDouble()
				End Select

				collection.Add(dataPoint)
			Next i

			Dim tmr As New DispatcherTimer()
			tmr.Interval = TimeSpan.FromMilliseconds(100)
			AddHandler tmr.Tick, AddressOf OnTimerTick
			tmr.Start()
		End Sub

		Private Function FabricateIdString() As String
			Dim str As String = ""
			Dim num As Integer = rand.Next(3, 11)
			Dim vowels() As Char = { "A"c, "E"c, "I"c, "O"c, "U"c }
			Dim cons() As Char = { "B"c, "C"c, "D"c, "F"c, "G"c, "H"c, "J"c, "K"c, "L"c, "M"c, "N"c, "P"c, "R"c, "S"c, "T"c, "V"c, "W"c, "Z"c }

			For i As Integer = 0 To num - 1
				Dim ch As Char = If((i Mod 2 = 0), cons(rand.Next(cons.Length)), vowels(rand.Next(vowels.Length)))
                If i = 0 Then
                    str &= ch
                Else
                    Char.ToLower(ch)
                End If
            Next i
			Return str
		End Function

		Private Sub OnTimerTick(ByVal sender As Object, ByVal args As EventArgs)
			For i As Integer = 0 To changePoints - 1
				Dim index As Integer = rand.Next(collection.Count)
				Dim dataPoint As T = collection(index)
				Dim change As Double = 0.1 * (rand.NextDouble() - 0.5)

				If rand.Next(2) = 0 Then
					dataPoint.VariableX = Math.Max(0, Math.Min(1, dataPoint.VariableX + change))
				Else
					dataPoint.VariableY = Math.Max(0, Math.Min(1, dataPoint.VariableY + change))
				End If
			Next i
		End Sub
	End Class
End Namespace