' SingleCellGrid.cs by Charles Petzold, December 2008

Imports Microsoft.VisualBasic
Imports System
Imports System.Windows
Imports System.Windows.Controls

Namespace DataLibrary
	Public Class SingleCellGrid
		Inherits Panel
		Private infiniteSize As New Size(Double.PositiveInfinity, Double.PositiveInfinity)

		Protected Overrides Function MeasureOverride(ByVal availableSize As Size) As Size
			Dim totalSize As New Size()

			For Each child As UIElement In InternalChildren
				child.Measure(infiniteSize)
				Dim childSize As Size = child.DesiredSize
				totalSize.Width = Math.Max(totalSize.Width, childSize.Width)
				totalSize.Height = Math.Max(totalSize.Height, childSize.Height)
			Next child

			Return totalSize
		End Function

		Protected Overrides Function ArrangeOverride(ByVal finalSize As Size) As Size
			For Each child As UIElement In InternalChildren
				child.Arrange(New Rect(New Point(), child.DesiredSize))
			Next child

			Return finalSize
		End Function
	End Class
End Namespace
